// GuruGuruSMF ver.4.0.0 wb_(C++X^C)

#ifndef _GURUGURUSMF4H_
#define _GURUGURUSMF4H_

#include <windows.h>

namespace GuruGuruSmf {

	namespace PlayOption
	{
		const int Loop = 1;			// [vĐ
		const int SkipBeginning = 2;	// `̋󔒂XLbv
		const int SkipEnding = 4;		// ̋󔒂XLbv
		const int MasterPitch = 8;		// }X^[sb`Lɂ
		const int Normalize = 16;		// ő剹ʂ127Ɉグ
		const int Exclusive = 32;		// GNXN[Vu𑗐M
	}
	
	namespace LoadOption
	{
		const int Buffered = 1;		// f[^ɕێ邩
	}
	
	namespace Device
	{
		const int DirectMusic = -1100;				// DirectMusic Port[h
	}
	
	namespace GgsError {
		enum Code {
			NoError, 			// G[Ȃ
			Failed,				// Ȃ񂾂悭킩Ȃǎs
			FileNotFound,		// t@C݂Ȃ
			CannotOpenFile,		// t@CJȂ
			FileLoadFailed,		// t@Cǂݍ݂Ɏs
			BadFileSize,		// t@CTCYs
			NoSmf,				// SMFł͂܂
			BadSmf,				// sSMF
			UnmatchedSmf,		// ΉSMF
			CannotOpenDevice,	// foCXJȂ
			CannotStartTimer,	// ^C}[JnłȂ
			IllegalPointer,		// ͈͊OQƂ悤Ƃ
			TrackLimit,			// bZ[W̓rŃgbNI[ɒB
			NotReady,			// t\ł͂Ȃ
			UndefinedId,		// `ID
			ApiNull				// APILłȂ
		};
	}
	typedef GgsError::Code GGSERROR;
	
	namespace PlayerState {
		enum Code {
			Stop,		// ~
			Play,		// t
			Pause		// ꎞ~
		};
	}
	typedef PlayerState::Code PLAYERSTATE;

	struct PlayerStatus
	{
		PLAYERSTATE State;
		int Tempo;
		int Tick;
		int Time;
		int LoopCount;
	};

	struct SmfInformation
	{
		int TimeBase;		// x[XJEg
		int TotalTick;		// Tick
		int TotalTime;		// t
		int FirstNoteTick;	// ŏ̔tick
		int FirstNoteTime;	// ŏ̔̎
		int LastNoteTick;	// Ō̔tick
		int LastNoteTime;	// Ō̔̎
		int LoopTick;		// CC#111̈ʒu
		int LoopTime;		// CC#111̈ʒu̎
	};

	struct SmfListKeys
	{
		int Count;		// L[̐
		int* Keys;		// L[̃Xg
	};
	
	class Ggs4
	{
	private:
		static Ggs4* instance;
		
		Ggs4(){}
		Ggs4(const Ggs4&);
		Ggs4& operator =(const Ggs4&);
		~Ggs4();
		
	public:
		GGSERROR OpenDevice(int deviceId, HWND handle);
		void CloseDevice();
		GGSERROR AddDlsW(LPCWSTR fileName);
		GGSERROR AddDlsA(LPCSTR fileName);
		GGSERROR Play(int option, int musicId, int seek, int fadeInTime, int keyShift);
		void Stop(int fadeOutTime);
		void Pause();
		void Restart();
		void SetMasterTempo(float tempo);
		void SetMasterVolume(int volume);
		void SetMasterPitch(int pitch);
		void GetPlayerStatus(PlayerStatus* status);
		GGSERROR AddListFromFileW(LPCWSTR fileName, int option, int musicId);
		GGSERROR AddListFromFileA(LPCSTR fileName, int option, int musicId);
		GGSERROR AddListFromMemory(LPCBYTE smfBinary, int length, int option, int musicId);
		void DeleteListItem(int musicId);
		void ClearList();
		const SmfListKeys* EnumList();
		GGSERROR GetSmfInformation(SmfInformation* info, int musicId);

		static GGSERROR Initialize();
		static Ggs4* GetInstance();
		static void FreeInstance();
	};

}

#define GGS GuruGuruSmf::Ggs4::GetInstance()
#define GGSINITIALIZE GuruGuruSmf::Ggs4::Initialize
#define GGSFREE GuruGuruSmf::Ggs4::FreeInstance

#endif

