#include <windows.h>

#include "kbGuru2SMF_module.h"
#include "kbGuru2SMF_player.h"

#ifdef _DEBUG
static const DWORD kbGuru2SMF_Version = 0x7FFFFFFF; //fobO͗Dxő
#define KBDMUSIC_VERSION_STR L"0x7FFFFFFF(Debug)"
#else
static const DWORD kbGuru2SMF_Version = 1;
#define KBDMUSIC_VERSION_STR L"0.01"
#endif
///////////////////////////////////////////////////////////////////////////////
// {ECE8C197-43F5-437A-9DD4-FF81CC7E52CC}
static const GUID kbGuru2SMF_GUID = 
{ 0xece8c197, 0x43f5, 0x437a, { 0x9d, 0xd4, 0xff, 0x81, 0xcc, 0x7e, 0x52, 0xcc } };

static const wchar_t kbGuru2SMF_Description[] = L"GuruGuruSMF Player v" KBDMUSIC_VERSION_STR ;
static const wchar_t kbGuru2SMF_Copyright[] =  L"Copyright(C) 2024 You";
static const wchar_t kbGuru2SMF_MultipleInstance = KPI_MULTINST_ONE;
static const DWORD kbGuru2SMF_SupportTagInfo = 0;
static const DWORD kbGuru2SMF_SupportConfig =  0;
static const wchar_t kbGuru2SMF_SupportExts[] = L".mid";
static const wchar_t kbGuru2SMF_MultiSongExts[] = L"";
static const wchar_t kbGuru2SMF_SupportCodecs[] = L"";
static const wchar_t kbGuru2SMF_SupportContainers[] = L"";
static void* kbGuru2SMF_Reserved1 = NULL;
static void* kbGuru2SMF_Reserved2 = NULL;
///////////////////////////////////////////////////////////////////////////////
KbGuru2SMFPlayerModule::KbGuru2SMFPlayerModule(IKpiConfig *pConfig)
    :m_ModuleInfo{
        sizeof(KPI_PLAYER_MODULEINFO),
        KPI_PLAYER_MODULE_VERSION,
        kbGuru2SMF_Version,
        kbGuru2SMF_MultipleInstance,
        kbGuru2SMF_GUID,
        kbGuru2SMF_Description,
        kbGuru2SMF_Copyright,
        kbGuru2SMF_SupportExts,
        kbGuru2SMF_MultiSongExts,
        kbGuru2SMF_Reserved1,
        kbGuru2SMF_Reserved2,
        kbGuru2SMF_SupportTagInfo,
        kbGuru2SMF_SupportConfig,
        0,0,0,0}
{
    m_pConfig = pConfig;
    pConfig->AddRef();
}
///////////////////////////////////////////////////////////////////////////////
KbGuru2SMFPlayerModule::~KbGuru2SMFPlayerModule(void)
{
    m_pConfig->Release();
}
///////////////////////////////////////////////////////////////////////////////
void WINAPI KbGuru2SMFPlayerModule::GetModuleInfo(const KPI_PLAYER_MODULEINFO **ppInfo)
{
    *ppInfo = &m_ModuleInfo;
}
///////////////////////////////////////////////////////////////////////////////
DWORD WINAPI KbGuru2SMFPlayerModule::Open(const KPI_MEDIAINFO *cpRequest, 
                                        IKpiFile   *pFile,
                                        IKpiFolder *pFolder,
                                        IKpiPlayer **ppPlayer)
{
    KbGuru2SMFPlayer *pPlayer = new KbGuru2SMFPlayer(m_pConfig);
    DWORD dwRet = pPlayer->Open(pFile, pFolder);
    if(dwRet == 0){
        pPlayer->Release();
        *ppPlayer = NULL;
    }
    else{
        *ppPlayer = pPlayer;
    }
    return dwRet;
}
///////////////////////////////////////////////////////////////////////////////
BOOL  WINAPI KbGuru2SMFPlayerModule::EnumConfig(IKpiConfigEnumerator *pEnumerator)
{
    return TRUE;
}
//////////////////////////////////////////////////////////////////////////////
DWORD WINAPI KbGuru2SMFPlayerModule::ApplyConfig(const wchar_t *cszSection, //ZNV
                                               const wchar_t *cszKey,     //L[
                                               INT64 nValue,
                                               double dValue,
                                               const wchar_t *cszValue)     
{
    m_pConfig->SetStr(cszSection, cszKey, cszValue);
    return KPI_CFGRET_RELOAD_DATA;
}
///////////////////////////////////////////////////////////////////////////////
HRESULT WINAPI kpi_CreateInstance(REFIID riid, void **ppvObject, IKpiUnknown *pUnknown)
{
    *ppvObject = NULL;
    if(!IsEqualIID(riid, IID_IKpiPlayerModule)){
        return E_NOINTERFACE;
    }
    IKpiConfig *pConfig = NULL;
    kpi_CreateConfig(pUnknown, &kbGuru2SMF_GUID, NULL, &pConfig);
    IKpiPlayerModule *pPlayerModule = new KbGuru2SMFPlayerModule(pConfig);
    *ppvObject = pPlayerModule;
    pConfig->Release();
    return S_OK;
}
